unit NavBtn;

{ $DEFINE DBSpeedButton}

{ TDBNavigationButton: a data-aware TBitBtn
                       (or TSpeedButton, if you $DEFINE DBSpeedButton)
  Delphi 1 - 3, CB1
  Version 1.7 Feb-03-1999
  (C)1997-99 Christoph R. Kirchner
  Freeware

  TDBNavigationButton has been renamed to TDBBitBtn (1997), but you can use
  this unit if you still use TDBNavigationButtons in your applications.
}

interface

{Detarmining compatibility}
{$IFDEF VER90}
{$DEFINE D2LIKE}
{$ENDIF}
{$IFDEF VER93}
{$DEFINE D2LIKE}
{$ENDIF}

uses
  SysUtils, Classes,
{$IFDEF DBSpeedButton}
  DBSBtn
{$ELSE DEF DBSpeedButton}
  DBBBtn
{$ENDIF DEF DBSpeedButton}
{$IFDEF WIN32}
  {$IFDEF D2LIKE} { Delphi = 2.x: }
    , Libconst;
  {$ELSE DEF D2LIKE} { Delphi >= 3.0: }
    ;
  {$ENDIF DEF D2LIKE}
{$ELSE DEF WIN32} { Delphi = 1.x: }
  , Libconst;
{$ENDIF DEF WIN32}

type

{$IFDEF DBSpeedButton}
  TDBNavigationButton = class(TDBSpeedButton)
{$ELSE DEF DBSpeedButton}
  TDBNavigationButton = class(TDBBitBtn)
{$ENDIF DEF DBSpeedButton}
  protected
    function CtrlNamePrefix: string; override;
  end;


procedure Register;

implementation


{$IFDEF WIN32}
  {$IFNDEF D2LIKE} { Delphi >= 3.0: }

const
{ RegisterPanel = 'Datensteuerung'; { german }
  RegisterPanel = 'Data Controls';

  {$ENDIF NDEF D2LIKE}
{$ENDIF DEF WIN32}


function TDBNavigationButton.CtrlNamePrefix: string;
begin
  result := 'dbNavBtn';
end;

{ Register ------------------------------------------------------------------ }


procedure Register;
begin
{$IFDEF WIN32}
  {$IFDEF D2LIKE} { Delphi = 2.x: }
    RegisterComponents(LoadStr(srDControls), [TDBNavigationButton]);
  {$ELSE DEF D2LIKE} { Delphi >= 3.0: }
    RegisterComponents(RegisterPanel, [TDBNavigationButton]);
  {$ENDIF DEF D2LIKE}
{$ELSE DEF WIN32} { Delphi = 1.x: }
  RegisterComponents(LoadStr(srDControls), [TDBNavigationButton]);
{$ENDIF DEF WIN32}
end;

end.
