unit TstRiFrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, Mask, DBCtrls,
  ExtCtrls, Buttons, DBSBtn, RInsSBtn, DBBBtn, NavBtn, RInsBBtn;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Table1NAME: TStringField;
    Table1SIZE: TSmallintField;
    Table1WEIGHT: TSmallintField;
    Table1AREA: TStringField;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    Panel1: TPanel;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    dbNavBtnDelete: TDBNavigationButton;
    dbNavBtnCancel: TDBNavigationButton;
    dbNavBtnSave: TDBNavigationButton;
    DBRepInsBitBtn1: TDBRepInsBitBtn;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DataSource1StateChange(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
{ Needs the Form's KeyPreview property set to True. }
begin
  if Key = #13 then                           {   if it's an enter key }
  begin
  { Enter-key needed in Memos for newline, else move to next control: }
    if not ((ActiveControl is tDbMemo) or (ActiveControl is tMemo)) then
    begin
      Key := #0;                              {   eat enter key        }
      Perform(WM_NEXTDLGCTL, 0, 0);           {   move to next control }
    end;
  end;
  if Key = #27 then  { esc: }
  begin
    if (DataSource1.State = dsInsert) then
    begin
      Key := #0;
      if (DBEdit1.Text = '') and (DBEdit2.Text = '') and
         (DBEdit3.Text = '') and (DBEdit4.Text = '') then
        DataSource1.DataSet.Cancel
      else
        DataSource1.DataSet.Post;
    end;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  MsgBoxResult: Integer;
begin
  if (DataSource1.State in [dsEdit, dsInsert]) then
  begin
    MsgBoxResult :=
      MessageDlg('Save changes ?', mtConfirmation, mbYesNoCancel, 0);
    if MsgBoxResult = mrYes then
      DataSource1.Dataset.Post
    else
      if MsgBoxResult = mrNo then
        DataSource1.Dataset.Cancel
      else
        CanClose := false;
    end;
end;

procedure TForm1.DataSource1StateChange(Sender: TObject);
begin
  if (DataSource1.State = dsInsert) then
    Label1.Caption := 'Move to next field with ENTER' + #10 +
                      'Press ESC to stop adding records'
  else
    Label1.Caption := #10 + 'Click on the [+] button to add records';
end;

end.
